Index: src/southbridge/sis/sis966/sis966.c
===================================================================
--- src/southbridge/sis/sis966/sis966.c	(revision 2923)
+++ src/southbridge/sis/sis966/sis966.c	(working copy)
@@ -49,7 +49,7 @@
 		) ) {
 			uint32_t id;
 			id = pci_read_config32(lpc_dev, PCI_VENDOR_ID);
-			if ( (id < (PCI_VENDOR_ID_SIS | (PCI_DEVICE_ID_SIS_SIS966_LPC << 16)))
+			if ( (id < (PCI_VENDOR_ID_SIS | (PCI_DEVICE_ID_SIS_SIS966_LPC << 16)))
 				) {
 				lpc_dev = 0;
 			}
@@ -62,19 +62,18 @@
 {
 	device_t lpc_dev = 0;
 	device_t sm_dev = 0;
-	unsigned index = 0;
-	unsigned index2 = 0;
+	uint16_t index = 0;
+	uint16_t index2 = 0;
 	uint32_t reg_old, reg;
 	uint8_t byte;
-	unsigned deviceid;
-	unsigned vendorid;
+	uint16_t deviceid;
+	uint16_t vendorid;
+	uint16_t devfn;

 	struct southbridge_sis_sis966_config *conf;
 	conf = dev->chip_info;
 	int i;

-	unsigned devfn;
-
 	if(dev->device==0x0000) {
 		vendorid = pci_read_config32(dev, PCI_VENDOR_ID);
 		deviceid = (vendorid>>16) & 0xffff;
@@ -88,25 +87,16 @@
 	switch(deviceid) {
 		case PCI_DEVICE_ID_SIS_SIS966_HT:
 			return;
-
-		case PCI_DEVICE_ID_SIS_SIS966_SM2://?
-			index = 16;
 			break;
 		case PCI_DEVICE_ID_SIS_SIS966_USB:
 			devfn -= (1<<3);
 			index = 8;
 			break;
-		case PCI_DEVICE_ID_SIS_SIS966_EHCI:
+		case PCI_DEVICE_ID_SIS_SIS966_USB2:
 			devfn -= (1<<3);
 			index = 20;
 			break;
-/*		case PCI_DEVICE_ID_SIS_SIS966_USB3:
-			devfn -= (1<<3);
-			index = 20;
-			break;
-*/
-		case PCI_DEVICE_ID_SIS_SIS966_NIC1: //two
-		case PCI_DEVICE_ID_SIS_SIS966_NIC_BRIDGE://two
+		case PCI_DEVICE_ID_SIS_SIS966_NIC1:
 			devfn -= (7<<3);
 			index = 10;
 			for(i=0;i<2;i++) {
@@ -125,8 +115,7 @@
 			devfn -= (3<<3);
 			index = 14;
 			break;
-		case PCI_DEVICE_ID_SIS_SIS966_SATA0: //three
-		case PCI_DEVICE_ID_SIS_SIS966_SATA1: //three
+		case PCI_DEVICE_ID_SIS_SIS966_SATA0:
 			devfn -= (4<<3);
 			index = 22;
 			i = (dev->path.u.pci.devfn) & 7;
@@ -138,11 +127,7 @@
 			devfn -= (5<<3);
 			index = 15;
 			break;
-//		case PCI_DEVICE_ID_SIS_SIS966_PCIE_A:
-//			devfn -= (0x9<<3);  // to LPC
-//			index2 = 9;
-//			break;
-		case PCI_DEVICE_ID_SIS_SIS966_PCIE_B_C: //two
+		case PCI_DEVICE_ID_SIS_SIS966_PCIE_B_C:
 			devfn -= (0xa<<3);  // to LPC
 			index2 = 8;
 			for(i=0;i<2;i++) {
@@ -216,17 +201,8 @@
 		if(!sm_dev) return;

 		final_reg = pci_read_config32(sm_dev, 0xe8);
-		final_reg &= ~((1<<16)|(1<<8)|(1<<20)|(1<<14)|(1<<22)|(1<<18)|(1<<17)|(1<<15)|(1<<11)|(1<<10)|(1<<9));
+		final_reg &= ~0x0057cf00;
 		pci_write_config32(sm_dev, 0xe8, final_reg); //enable all at first
-#if 0
-		reg_old = reg = pci_read_config32(sm_dev, 0xe4);
-//		reg |= (1<<0);
-		reg &= ~(0x3f<<4);
-		if (reg != reg_old) {
-			printk_debug("sis966.c pcie enabled\n");
-			pci_write_config32(sm_dev, 0xe4, reg);
-		}
-#endif
 	}

 	if (!dev->enabled) {
Index: src/southbridge/sis/sis966/sis966.h
===================================================================
--- src/southbridge/sis/sis966/sis966.h	(revision 2923)
+++ src/southbridge/sis/sis966/sis966.h	(working copy)
@@ -1,8 +1,6 @@
 /*
  * This file is part of the LinuxBIOS project.
  *
- * Copyright (C) 2007 AMD
- * Written by Yinghai Lu <yinghai.lu@amd.com> for AMD.
  * Copyright (C) 2007 Silicon Integrated Systems Corp. (SiS)
  * Written by Morgan Tsai <my_tsai@sis.com> for SiS.
  *
@@ -24,6 +22,13 @@
 #ifndef SIS966_H
 #define SIS966_H

+#define DEBUG_AZA 0
+#define DEBUG_NIC 0
+#define DEBUG_IDE 0
+#define DEBUG_SATA 0
+#define DEBUG_USB 0
+#define DEBUG_USB2 0
+
 #include "chip.h"

 void sis966_enable(device_t dev);
Index: src/southbridge/sis/sis966/sis966_aza.c
===================================================================
--- src/southbridge/sis/sis966/sis966_aza.c	(revision 2923)
+++ src/southbridge/sis/sis966/sis966_aza.c	(working copy)
@@ -32,10 +32,10 @@
 #include "sis966.h"

 uint8_t	SiS_SiS7502_init[7][3]={
-{0x04, 0xFF, 0x07},
-{0x2C, 0xFF, 0x39},
-{0x2D, 0xFF, 0x10},
-{0x2E, 0xFF, 0x91},
+{0x04, 0xFF, 0x07},
+{0x2C, 0xFF, 0x39},
+{0x2D, 0xFF, 0x10},
+{0x2E, 0xFF, 0x91},
 {0x2F, 0xFF, 0x01},
 {0x04, 0xFF, 0x06},
 {0x00, 0x00, 0x00}					//End of table
@@ -61,7 +61,7 @@

 	if(!count) return -1;

-	udelay(540);
+	udelay(500);
 	return 0;

 }
@@ -71,30 +71,29 @@


      uint32_t dword;
-
+
      dword = readl(base + 0x68);
      dword=dword|(unsigned long)0x0002;
      writel(dword,base + 0x68);
-     do {
-	 	dword = readl(base + 0x68);
+     do {
+	 	dword = readl(base + 0x68);
      }  while ((dword & 1)!=0);
      writel(verb, base + 0x60);
-     udelay(500);
-     dword = readl(base + 0x68);
-     dword =(dword |0x1);
+     udelay(500);
+     dword = readl(base + 0x68);
+     dword =(dword |0x1);
      writel(dword, base + 0x68);
      do {
-	 	udelay(120);
+	 	udelay(100);
 		dword = readl(base + 0x68);
      } while ((dword & 3) != 2);

      dword = readl(base + 0x64);
      return dword;
-
+
 }


-#if 1
 static int codec_detect(uint8_t *base)
 {
 	uint32_t dword;
@@ -102,97 +101,31 @@

 	/* 1 */ // controller reset
 	printk_debug("controller reset\n");
-
+
 	set_bits(base + 0x08, 1, 1);
-
+
       do{
-	  	dword = readl(base + 0x08)&0x1;
+	  	dword = readl(base + 0x08)&0x1;
 		if(idx++>1000) { printk_debug("controller reset fail !!! \n"); break;}
 	   } while (dword !=1);
-
+
        dword=send_verb(base,0x000F0000); // get codec VendorId and DeviceId
-
+
        if(dword==0) {
 	   	printk_debug("No codec!\n");
 		return 0;
        }

 	 printk_debug("Codec ID = %lx\n", dword);
-
-#if 0
-	/* 2 */
-	dword = readl(base + 0x0e);
-	dword |= 7;
-	writel(dword, base + 0x0e);

-	/* 3 */
-	set_bits(base + 0x08, 1, 0);
-
-	/* 4 */
-	set_bits(base + 0x08, 1, 1);
-
-	/* 5 */
-	dword = readl(base + 0xe);
-	dword &= 7;
-
-	/* 6 */
-	if(!dword) {
-		set_bits(base + 0x08, 1, 0);
-		printk_debug("No codec!\n");
-		return 0;
-	}
-#endif
        dword=0x1;
 	return dword;

 }

-#else

-static int codec_detect(uint8_t *base)
-{
-	uint32_t dword;
-
-	/* 1 */
-	set_bits(base + 0x08, 1, 1);
-
-	/* 2 */
-	dword = readl(base + 0x0e);
-	dword |= 7;
-	writel(dword, base + 0x0e);
-
-	/* 3 */
-	set_bits(base + 0x08, 1, 0);
-
-	/* 4 */
-	set_bits(base + 0x08, 1, 1);
-
-	/* 5 */
-	dword = readl(base + 0xe);
-	dword &= 7;
-
-	/* 6 */
-	if(!dword) {
-		set_bits(base + 0x08, 1, 0);
-		printk_debug("No codec!\n");
-		return 0;
-	}
-	return dword;
-
-}
-
-#endif
-
-#if 1
-
-// For SiS demo board PinConfig
 static uint32_t verb_data[] = {
-#if 0
- 00172083h,
- 00172108h,
- 001722ECh,
- 00172310h,
-#endif
+
 //14
 	0x01471c10,
 	0x01471d40,
@@ -255,79 +188,6 @@
 	0x01f71f01,
 };

-#else
-// orginal codec pin configuration setting
-
-static uint32_t verb_data[] = {
-#if 0
-	0x00172001,
-	0x001721e6,
-	0x00172200,
-	0x00172300,
-#endif
-
-	0x01471c10,
-	0x01471d44,
-	0x01471e01,
-	0x01471f01,
-//1
-	0x01571c12,
-	0x01571d14,
-	0x01571e01,
-	0x01571f01,
-//2
-	0x01671c11,
-	0x01671d60,
-	0x01671e01,
-	0x01671f01,
-//3
-	0x01771c14,
-	0x01771d20,
-	0x01771e01,
-	0x01771f01,
-//4
-	0x01871c30,
-	0x01871d9c,
-	0x01871ea1,
-	0x01871f01,
-//5
-	0x01971c40,
-	0x01971d9c,
-	0x01971ea1,
-	0x01971f02,
-//6
-	0x01a71c31,
-	0x01a71d34,
-	0x01a71e81,
-	0x01a71f01,
-//7
-	0x01b71c1f,
-	0x01b71d44,
-	0x01b71e21,
-	0x01b71f02,
-//8
-	0x01c71cf0,
-	0x01c71d11,
-	0x01c71e11,
-	0x01c71f41,
-//9
-	0x01d71c3e,
-	0x01d71d01,
-	0x01d71e83,
-	0x01d71f99,
-//10
-	0x01e71c20,
-	0x01e71d41,
-	0x01e71e45,
-	0x01e71f01,
-//11
-	0x01f71c50,
-	0x01f71d91,
-	0x01f71ec5,
-	0x01f71f01,
-};
-
-#endif
 static unsigned find_verb(uint32_t viddid, uint32_t **verb)
 {
         if((viddid == 0x10ec0883) || (viddid == 0x10ec0882) || (viddid == 0x10ec0880)) return 0;
@@ -370,17 +230,6 @@
 	/* 3 */
 	for(i=0; i<verb_size; i++) {
 		send_verb(base,verb[i]);
-#if 0
-		do {
-			dword = readl(base + 0x68);
-		} while (dword & 1);
-
-		writel(verb[i], base + 0x60);
-
-		do {
-			dword = readl(base + 0x68);
-		} while ((dword & 3) != 2);
-#endif
 	}
 	printk_debug("verb loaded!\n");
 }
@@ -398,43 +247,48 @@

 static void aza_init(struct device *dev)
 {
-	uint8_t *base;
-	struct resource *res;
-	uint32_t codec_mask;
+        uint8_t *base;
+        struct resource *res;
+        uint32_t codec_mask;

+        print_debug("AZALIA_INIT:---------->\n");

 //-------------- enable AZA (SiS7502) -------------------------
 {
-       uint8_t  temp8;
-       int i=0;
-	while(SiS_SiS7502_init[i][0] != 0)
-	{				temp8 = pci_read_config8(dev, SiS_SiS7502_init[i][0]);
-					temp8 &= SiS_SiS7502_init[i][1];
-					temp8 |= SiS_SiS7502_init[i][2];
-					pci_write_config8(dev, SiS_SiS7502_init[i][0], temp8);
-					i++;
-	};
+        uint8_t  temp8;
+        int i=0;
+        while(SiS_SiS7502_init[i][0] != 0)
+        {
+                temp8 = pci_read_config8(dev, SiS_SiS7502_init[i][0]);
+                temp8 &= SiS_SiS7502_init[i][1];
+                temp8 |= SiS_SiS7502_init[i][2];
+                pci_write_config8(dev, SiS_SiS7502_init[i][0], temp8);
+                i++;
+        };
 }
 //-----------------------------------------------------------


-// put audio to D0 state
-pci_write_config8(dev, 0x54,0x00);
+        // put audio to D0 state
+        pci_write_config8(dev, 0x54,0x00);

-#if 0
+#if DEBUG_AZA
 {
-    int i;
-    printk_debug("Azalia PCI config \n");
-    for(i=0;i<0xFF;i+=4)
-    {
-        if((i%16)==0)
-        {
-            print_debug("\r\n");print_debug_hex8(i);print_debug("  ");
+        int i;
+
+        print_debug("****** Azalia PCI config ******");
+        print_debug("\n    03020100  07060504  0B0A0908  0F0E0D0C");
+
+        for(i=0;i<0xff;i+=4){
+                if((i%16)==0){
+                        print_debug("\r\n");
+                        print_debug_hex8(i);
+                        print_debug(": ");
+                }
+                print_debug_hex32(pci_read_config32(dev,i));
+                print_debug("  ");
         }
-        print_debug_hex32(pci_read_config32(dev,i));
-        print_debug("  ");
-    }
-    print_debug("\r\n");
+        print_debug("\r\n");
 }
 #endif

@@ -452,26 +306,9 @@
 		codecs_init(base, codec_mask);
 	}

-#if 0
-{
-    int i;
-    printk_debug("Azalia PCI config \n");
-    for(i=0;i<0xFF;i+=4)
-    {
-        if((i%16)==0)
-        {
-            print_debug("\r\n");print_debug_hex8(i);print_debug("  ");
-        }
-        outl(0x80000800+i,0xcf8);
-        print_debug_hex32(inl(0xcfc));
-        print_debug("  ");
-    }
-    print_debug("\r\n");
+        print_debug("AZALIA_INIT:<----------\n");
 }
-#endif

-}
-
 static void lpci_set_subsystem(device_t dev, unsigned vendor, unsigned device)
 {
 	pci_write_config32(dev, 0x40,
Index: src/southbridge/sis/sis966/sis966_early_ctrl.c
===================================================================
--- src/southbridge/sis/sis966/sis966_early_ctrl.c	(revision 2923)
+++ src/southbridge/sis/sis966/sis966_early_ctrl.c	(working copy)
@@ -51,10 +51,10 @@
 static void soft_reset(void)
 {
 	set_bios_reset();
-#if 1
+
 	/* link reset */
 	outb(0x02, 0x0cf9);
 	outb(0x06, 0x0cf9);
-#endif
+
 }

Index: src/southbridge/sis/sis966/sis966_early_setup_car.c
===================================================================
--- src/southbridge/sis/sis966/sis966_early_setup_car.c	(revision 2923)
+++ src/southbridge/sis/sis966/sis966_early_setup_car.c	(working copy)
@@ -21,125 +21,6 @@
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
  */

-static int set_ht_link_sis966(uint8_t ht_c_num)
-{
-	unsigned vendorid = 0x10de;
-	unsigned val = 0x01610109;
-	/* Nvidia sis966 hardcode, hw can not set it automatically */
-	return set_ht_link_buffer_counts_chain(ht_c_num, vendorid, val);
-}
-
-static void setup_ss_table(unsigned index, unsigned where, unsigned control, const unsigned int *register_values, int max)
-{
-	int i;
-
-	unsigned val;
-
-	val = inl(control);
-	val &= 0xfffffffe;
-	outl(val, control);
-
-	outl(0, index); //index
-	for(i = 0; i < max; i++) {
-		unsigned long reg;
-		reg = register_values[i];
-		outl(reg, where);
-	}
-
-	val = inl(control);
-	val |= 1;
-	outl(val, control);
-
-}
-
-/* SIZE 0x100 */
-#define ANACTRL_IO_BASE	0x2800
-#define ANACTRL_REG_POS	0x68
-
-/* SIZE 0x100 */
-#define SYSCTRL_IO_BASE	0x2400
-#define SYSCTRL_REG_POS	0x64
-
-/* SIZE 0x100 */
-#define ACPICTRL_IO_BASE	0x2000
-#define ACPICTRL_REG_POS	0x60
-
-/*
-	16 1 1 1 1 8 :0
-	16 0 4 0 0 8 :1
-	16 0 4 2 2 4 :2
-	 4 4 4 4 4 8 :3
-	 8 8 4 0 0 8 :4
-	 8 0 4 4 4 8 :5
-*/
-
-#ifndef SIS966_PCI_E_X_0
-	#define SIS966_PCI_E_X_0	4
-#endif
-#ifndef SIS966_PCI_E_X_1
-	#define SIS966_PCI_E_X_1	4
-#endif
-#ifndef SIS966_PCI_E_X_2
-	#define SIS966_PCI_E_X_2	4
-#endif
-#ifndef SIS966_PCI_E_X_3
-	#define SIS966_PCI_E_X_3	4
-#endif
-
-#ifndef SIS966_USE_NIC
-	#define SIS966_USE_NIC	0
-#endif
-
-#ifndef SIS966_USE_AZA
-	#define SIS966_USE_AZA	0
-#endif
-
-#define SIS966_CHIP_REV	3
-
-static void sis966_early_set_port(unsigned sis966_num, unsigned *busn, unsigned *devn, unsigned *io_base)
-{
-
-	static const unsigned int ctrl_devport_conf[] = {
-		PCI_ADDR(0, 1, 1, ANACTRL_REG_POS), ~(0x0000ff00), ANACTRL_IO_BASE,
-		PCI_ADDR(0, 1, 1, SYSCTRL_REG_POS), ~(0x0000ff00), SYSCTRL_IO_BASE,
-		PCI_ADDR(0, 1, 1, ACPICTRL_REG_POS), ~(0x0000ff00), ACPICTRL_IO_BASE,
-	};
-
-	int j;
-	for(j = 0; j < sis966_num; j++ ) {
-		setup_resource_map_offset(ctrl_devport_conf,
-			sizeof(ctrl_devport_conf)/sizeof(ctrl_devport_conf[0]),
-			PCI_DEV(busn[j], devn[j], 0) , io_base[j]);
-	}
-}
-
-static void sis966_early_clear_port(unsigned sis966_num, unsigned *busn, unsigned *devn, unsigned *io_base)
-{
-
-	static const unsigned int ctrl_devport_conf_clear[] = {
-		PCI_ADDR(0, 1, 1, ANACTRL_REG_POS), ~(0x0000ff00), 0,
-		PCI_ADDR(0, 1, 1, SYSCTRL_REG_POS), ~(0x0000ff00), 0,
-		PCI_ADDR(0, 1, 1, ACPICTRL_REG_POS), ~(0x0000ff00), 0,
-	};
-
-	int j;
-	for(j = 0; j < sis966_num; j++ ) {
-		setup_resource_map_offset(ctrl_devport_conf_clear,
-			sizeof(ctrl_devport_conf_clear)/sizeof(ctrl_devport_conf_clear[0]),
-			PCI_DEV(busn[j], devn[j], 0) , io_base[j]);
-	}
-
-
-}
-static void delayx(uint8_t value) {
-#if 1
-	int i;
-	for(i=0;i<0x8000;i++) {
-		outb(value, 0x80);
-	}
-#endif
-}
-
 static void sis966_early_pcie_setup(unsigned busnx, unsigned devnx, unsigned anactrl_io_base, unsigned pci_e_x)
 {
 	uint32_t tgio_ctrl;
@@ -170,260 +51,13 @@
 	outl(tgio_ctrl, anactrl_io_base + 0xcc);

 //	wait 100us
-	delayx(1);
+	udelay(100);

 	dword = pci_read_config32(dev, 0xe4);
 	dword &= ~(0x3f0); // enable
 	pci_write_config32(dev, 0xe4, dword);

 //	need to wait 100ms
-	delayx(1000);
+	mdelay(100);
 }

-static void sis966_early_setup(unsigned sis966_num, unsigned *busn, unsigned *devn, unsigned *io_base, unsigned *pci_e_x)
-{
-
-    static const unsigned int ctrl_conf_1[] = {
-	RES_PORT_IO_32, ACPICTRL_IO_BASE + 0x10, 0x0007ffff, 0xff78000,
-	RES_PORT_IO_32, ACPICTRL_IO_BASE + 0xa4, 0xffedffff, 0x0012000,
-	RES_PORT_IO_32, ACPICTRL_IO_BASE + 0xac, 0xfffffdff, 0x0000200,
-	RES_PORT_IO_32, ACPICTRL_IO_BASE + 0xb4, 0xfffffffd, 0x0000002,
-
-	RES_PORT_IO_32, ANACTRL_IO_BASE + 0x24, 0xc0f0f08f, 0x26020230,
-	RES_PORT_IO_32, ANACTRL_IO_BASE + 0x34, 0x00000000, 0x22222222,
-	RES_PORT_IO_32, ANACTRL_IO_BASE + 0x08, 0x7FFFFFFF, 0x00000000,
-	RES_PORT_IO_32, ANACTRL_IO_BASE + 0x2C, 0x7FFFFFFF, 0x80000000,
-	RES_PORT_IO_32, ANACTRL_IO_BASE + 0xCC, 0xFFFFF9FF, 0x00000000,
-	RES_PORT_IO_32, ANACTRL_IO_BASE + 0x30, 0x8FFFFFFF, 0x40000000,
-	RES_PORT_IO_32, ANACTRL_IO_BASE + 0xCC, 0xFFFFF9FF, 0x00000200,
-	RES_PORT_IO_32, ANACTRL_IO_BASE + 0x30, 0x8FFFFFFF, 0x40000000,
-	RES_PORT_IO_32, ANACTRL_IO_BASE + 0xCC, 0xFFFFF9FF, 0x00000400,
-	RES_PORT_IO_32, ANACTRL_IO_BASE + 0x30, 0x8FFFFFFF, 0x40000000,
-	RES_PORT_IO_32, ANACTRL_IO_BASE + 0x74, 0xFFFF0FF5, 0x0000F000,
-	RES_PORT_IO_32, ANACTRL_IO_BASE + 0x78, 0xFF00FF00, 0x00100010,
-	RES_PORT_IO_32, ANACTRL_IO_BASE + 0x7C, 0xFF0FF0FF, 0x00500500,
-	RES_PORT_IO_32, ANACTRL_IO_BASE + 0x80, 0xFFFFFFE7, 0x00000000,
-	RES_PORT_IO_32, ANACTRL_IO_BASE + 0x60, 0xFFCFFFFF, 0x00300000,
-	RES_PORT_IO_32, ANACTRL_IO_BASE + 0x90, 0xFFFF00FF, 0x0000FF00,
-	RES_PORT_IO_32, ANACTRL_IO_BASE + 0x9C, 0xFF00FFFF, 0x00070000,
-
-	RES_PCI_IO, PCI_ADDR(0, 0, 0, 0x40), 0x00000000, 0xCB8410DE,
-	RES_PCI_IO, PCI_ADDR(0, 0, 0, 0x48), 0xFFFFDCED, 0x00002002,
-	RES_PCI_IO, PCI_ADDR(0, 0, 0, 0x78), 0xFFFFFF8E, 0x00000011,
-	RES_PCI_IO, PCI_ADDR(0, 0, 0, 0x80), 0xFFFF0000, 0x00009923,
-	RES_PCI_IO, PCI_ADDR(0, 0, 0, 0x88), 0xFFFFFFFE, 0x00000000,
-	RES_PCI_IO, PCI_ADDR(0, 0, 0, 0x8C), 0xFFFF0000, 0x0000007F,
-	RES_PCI_IO, PCI_ADDR(0, 0, 0, 0xDC), 0xFFFEFFFF, 0x00010000,
-
-	RES_PCI_IO, PCI_ADDR(0, 1, 0, 0x40), 0x00000000, 0xCB8410DE,
-	RES_PCI_IO, PCI_ADDR(0, 1, 0, 0x74), 0xFFFFFF7B, 0x00000084,
-	RES_PCI_IO, PCI_ADDR(0, 1, 0, 0xF8), 0xFFFFFFCF, 0x00000010,
-
-	RES_PCI_IO, PCI_ADDR(0, 1, 1, 0xC4), 0xFFFFFFFE, 0x00000001,
-	RES_PCI_IO, PCI_ADDR(0, 1, 1, 0xF0), 0x7FFFFFFD, 0x00000002,
-	RES_PCI_IO, PCI_ADDR(0, 1, 1, 0xF8), 0xFFFFFFCF, 0x00000010,
-
-	RES_PCI_IO, PCI_ADDR(0, 8, 0, 0x40), 0x00000000, 0xCB8410DE,
-	RES_PCI_IO, PCI_ADDR(0, 8, 0, 0x68), 0xFFFFFF00, 0x000000FF,
-	RES_PCI_IO, PCI_ADDR(0, 8, 0, 0xF8), 0xFFFFFFBF, 0x00000040,//Enable bridge mode
-
-	RES_PCI_IO, PCI_ADDR(0, 9, 0, 0x40), 0x00000000, 0xCB8410DE,
-	RES_PCI_IO, PCI_ADDR(0, 9, 0, 0x68), 0xFFFFFF00, 0x000000FF,
-	RES_PCI_IO, PCI_ADDR(0, 9, 0, 0xF8), 0xFFFFFFBF, 0x00000040,//Enable bridge mode
-    };
-
-    static const unsigned int ctrl_conf_1_1[] = {
-	RES_PCI_IO, PCI_ADDR(0, 5, 0, 0x40), 0x00000000, 0xCB8410DE,
-	RES_PCI_IO, PCI_ADDR(0, 5, 0, 0x50), 0xFFFFFFFC, 0x00000003,
-	RES_PCI_IO, PCI_ADDR(0, 5, 0, 0x64), 0xFFFFFFFE, 0x00000001,
-	RES_PCI_IO, PCI_ADDR(0, 5, 0, 0x70), 0xFFF0FFFF, 0x00040000,
-	RES_PCI_IO, PCI_ADDR(0, 5, 0, 0xAC), 0xFFFFF0FF, 0x00000100,
-	RES_PCI_IO, PCI_ADDR(0, 5, 0, 0x7C), 0xFFFFFFEF, 0x00000000,
-	RES_PCI_IO, PCI_ADDR(0, 5, 0, 0xC8), 0xFF00FF00, 0x000A000A,
-	RES_PCI_IO, PCI_ADDR(0, 5, 0, 0xD0), 0xF0FFFFFF, 0x03000000,
-	RES_PCI_IO, PCI_ADDR(0, 5, 0, 0xE0), 0xF0FFFFFF, 0x03000000,
-    };
-
-
-    static const unsigned int ctrl_conf_sis966_only[] = {
-	RES_PCI_IO, PCI_ADDR(0, 1, 1, 0x40), 0x00000000, 0xCB8410DE,
-	RES_PCI_IO, PCI_ADDR(0, 1, 1, 0xE0), 0xFFFFFEFF, 0x00000000,
-	RES_PCI_IO, PCI_ADDR(0, 1, 1, 0xE4), 0xFFFFFFFB, 0x00000000,
-	RES_PCI_IO, PCI_ADDR(0, 1, 1, 0xE8), 0xFFA9C8FF, 0x00003000,
-
-//	RES_PCI_IO, PCI_ADDR(0, 4, 0, 0x40), 0x00000000, 0xCB8410DE,
-//	RES_PCI_IO, PCI_ADDR(0, 4, 0, 0xF8), 0xFFFFFFCF, 0x00000010,
-
-	RES_PCI_IO, PCI_ADDR(0, 2, 0, 0x40), 0x00000000, 0xCB8410DE,
-
-	RES_PCI_IO, PCI_ADDR(0, 2, 1, 0x40), 0x00000000, 0xCB8410DE,
-	RES_PCI_IO, PCI_ADDR(0, 2, 1, 0x64), 0xF87FFFFF, 0x05000000,
-	RES_PCI_IO, PCI_ADDR(0, 2, 1, 0x78), 0xFFC07FFF, 0x00360000,
-	RES_PCI_IO, PCI_ADDR(0, 2, 1, 0x68), 0xFE00D03F, 0x013F2C00,
-	RES_PCI_IO, PCI_ADDR(0, 2, 1, 0x70), 0xFFF7FFFF, 0x00080000,
-	RES_PCI_IO, PCI_ADDR(0, 2, 1, 0x7C), 0xFFFFF00F, 0x00000570,
-	RES_PCI_IO, PCI_ADDR(0, 2, 1, 0xF8), 0xFFFFFFCF, 0x00000010,
-
-	RES_PCI_IO, PCI_ADDR(0, 6, 0, 0x04), 0xFFFFFEFB, 0x00000104,
-	RES_PCI_IO, PCI_ADDR(0, 6, 0, 0x3C), 0xF5FFFFFF, 0x0A000000,
-	RES_PCI_IO, PCI_ADDR(0, 6, 0, 0x40), 0x00C8FFFF, 0x07330000,
-	RES_PCI_IO, PCI_ADDR(0, 6, 0, 0x48), 0xFFFFFFF8, 0x00000005,
-	RES_PCI_IO, PCI_ADDR(0, 6, 0, 0x4C), 0xFE02FFFF, 0x004C0000,
-	RES_PCI_IO, PCI_ADDR(0, 6, 0, 0x74), 0xFFFFFFC0, 0x00000000,
-	RES_PCI_IO, PCI_ADDR(0, 6, 0, 0xC0), 0x00000000, 0xCB8410DE,
-	RES_PCI_IO, PCI_ADDR(0, 6, 0, 0xC4), 0xFFFFFFF8, 0x00000007,
-
-#if SIS966_USE_AZA == 1
-	RES_PCI_IO, PCI_ADDR(0, 6, 1, 0x40), 0x00000000, 0xCB8410DE,
-
-//	RES_PCI_IO, PCI_ADDR(0, 1, 1, 0xE4), ~(1<<14), 1<<14,
-#endif
-// play a while with GPIO in SIS966
-#ifdef SIS966_MB_SETUP
-	SIS966_MB_SETUP
-#endif
-
-#if SIS966_USE_AZA == 1
-	RES_PORT_IO_8, SYSCTRL_IO_BASE + 0xc0+ 21, ~(3<<2), (2<<2),
-	RES_PORT_IO_8, SYSCTRL_IO_BASE + 0xc0+ 22, ~(3<<2), (2<<2),
-	RES_PORT_IO_8, SYSCTRL_IO_BASE + 0xc0+ 46, ~(3<<2), (2<<2),
-#endif
-
-
-    };
-
-    static const unsigned int ctrl_conf_master_only[] = {
-
-	RES_PORT_IO_32, ACPICTRL_IO_BASE + 0x80, 0xEFFFFFF, 0x01000000,
-
-	RES_PCI_IO, PCI_ADDR(0, 1, 0, 0x78), 0xC0FFFFFF, 0x19000000,
-
-	//Master SIS966 ????YHLU
-	RES_PORT_IO_8, SYSCTRL_IO_BASE + 0xc0+ 0, ~(3<<2), (0<<2),
-
-    };
-
-    static const unsigned int ctrl_conf_2[] = {
-	/* I didn't put pcie related stuff here */
-
-	RES_PCI_IO, PCI_ADDR(0, 0, 0, 0x74), 0xFFFFF00F, 0x000009D0,
-	RES_PCI_IO, PCI_ADDR(0, 1, 0, 0x74), 0xFFFF7FFF, 0x00008000,
-
-	RES_PORT_IO_32, SYSCTRL_IO_BASE + 0x48, 0xFFFEFFFF, 0x00010000,
-
-	RES_PORT_IO_32, ANACTRL_IO_BASE + 0x60, 0xFFFFFF00, 0x00000012,
-
-
-#if SIS966_USE_NIC == 1
-	RES_PCI_IO, PCI_ADDR(0, 1, 1, 0xe4), ~((1<<22)|(1<<20)), (1<<22)|(1<<20),
-
-	RES_PORT_IO_8, SYSCTRL_IO_BASE + 0xc0+ 4, ~(0xff),  ((0<<4)|(1<<2)|(0<<0)),
-	RES_PORT_IO_8, SYSCTRL_IO_BASE + 0xc0+ 4, ~(0xff),  ((0<<4)|(1<<2)|(1<<0)),
-#endif
-
-    };
-
-
-	int j, i;
-
-	for(j=0; j<sis966_num; j++) {
-		sis966_early_pcie_setup(busn[j], devn[j], io_base[j] + ANACTRL_IO_BASE, pci_e_x[j]);
-
-		setup_resource_map_x_offset(ctrl_conf_1, sizeof(ctrl_conf_1)/sizeof(ctrl_conf_1[0]),
-				PCI_DEV(busn[j], devn[j], 0), io_base[j]);
-		for(i=0; i<3; i++) { // three SATA
-			setup_resource_map_x_offset(ctrl_conf_1_1, sizeof(ctrl_conf_1_1)/sizeof(ctrl_conf_1_1[0]),
-				PCI_DEV(busn[j], devn[j], i), io_base[j]);
-		}
-		if(busn[j] == 0) {
-			setup_resource_map_x_offset(ctrl_conf_sis966_only, sizeof(ctrl_conf_sis966_only)/sizeof(ctrl_conf_sis966_only[0]),
-				PCI_DEV(busn[j], devn[j], 0), io_base[j]);
-		}
-
-		if( (busn[j] == 0) && (sis966_num>1) ) {
-			setup_resource_map_x_offset(ctrl_conf_master_only, sizeof(ctrl_conf_master_only)/sizeof(ctrl_conf_master_only[0]),
-				PCI_DEV(busn[j], devn[j], 0), io_base[j]);
-		}
-
-		setup_resource_map_x_offset(ctrl_conf_2, sizeof(ctrl_conf_2)/sizeof(ctrl_conf_2[0]),
-				PCI_DEV(busn[j], devn[j], 0), io_base[j]);
-
-	}
-
-#if 0
-	for(j=0; j< sis966_num; j++) {
-		// PCI-E (XSPLL) SS table 0x40, x044, 0x48
-		// SATA  (SPPLL) SS table 0xb0, 0xb4, 0xb8
-		// CPU   (PPLL)  SS table 0xc0, 0xc4, 0xc8
-		setup_ss_table(io_base[j] + ANACTRL_IO_BASE+0x40, io_base[j] + ANACTRL_IO_BASE+0x44,
-			io_base[j] + ANACTRL_IO_BASE+0x48, pcie_ss_tbl, 64);
-		setup_ss_table(io_base[j] + ANACTRL_IO_BASE+0xb0, io_base[j] + ANACTRL_IO_BASE+0xb4,
-			io_base[j] + ANACTRL_IO_BASE+0xb8, sata_ss_tbl, 64);
-		setup_ss_table(io_base[j] + ANACTRL_IO_BASE+0xc0, io_base[j] + ANACTRL_IO_BASE+0xc4,
-			io_base[j] + ANACTRL_IO_BASE+0xc8, cpu_ss_tbl, 64);
-	}
-#endif
-
-}
-
-#ifndef HT_CHAIN_NUM_MAX
-
-#define HT_CHAIN_NUM_MAX	4
-#define HT_CHAIN_BUSN_D	0x40
-#define HT_CHAIN_IOBASE_D	0x4000
-
-#endif
-
-static int sis966_early_setup_x(void)
-{
-	/*find out how many sis966 we have */
-	unsigned busn[HT_CHAIN_NUM_MAX];
-	unsigned devn[HT_CHAIN_NUM_MAX];
-	unsigned io_base[HT_CHAIN_NUM_MAX];
-	/*
-		FIXME: May have problem if there is different SIS966 HTX card with different PCI_E lane allocation
-		Need to use same trick about pci1234 to verify node/link connection
-	*/
-	unsigned pci_e_x[HT_CHAIN_NUM_MAX] = {SIS966_PCI_E_X_0, SIS966_PCI_E_X_1, SIS966_PCI_E_X_2, SIS966_PCI_E_X_3 };
-	int sis966_num = 0;
-	unsigned busnx;
-	unsigned devnx;
-	int ht_c_index,j;
-
-	/* FIXME: multi pci segment handling */
-
-	/* Any system that only have IO55 without SIS966? */
-	for(ht_c_index = 0; ht_c_index<HT_CHAIN_NUM_MAX; ht_c_index++) {
-		busnx = ht_c_index * HT_CHAIN_BUSN_D;
-		for(devnx=0;devnx<0x20;devnx++) {
-			uint32_t id;
-			device_t dev;
-			dev = PCI_DEV(busnx, devnx, 0);
-			id = pci_read_config32(dev, PCI_VENDOR_ID);
-			if(id == 0x036910de) {
-				busn[sis966_num] = busnx;
-				devn[sis966_num] = devnx;
-				io_base[sis966_num] = ht_c_index * HT_CHAIN_IOBASE_D; // we may have ht chain other than SIS966
-				sis966_num++;
-				if(sis966_num == SIS966_NUM) goto out;
-				break; // only one SIS966 on one chain
-			}
-		}
-	}
-
-out:
-	print_debug("sis966_num:"); print_debug_hex8(sis966_num); print_debug("\r\n");
-
-	//sis966_early_set_port(sis966_num, busn, devn, io_base);
-	//sis966_early_setup(sis966_num, busn, devn, io_base, pci_e_x);
-
-	//sis966_early_clear_port(sis966_num, busn, devn, io_base);
-
-//	set_ht_link_sis966(HT_CHAIN_NUM_MAX);
-
-	return 0;
-
-}
-
-
-
